// Generated by CoffeeScript 1.9.3
(function() {
	var VamtamInstafeed;

	VamtamInstafeed = (function() {
	  function VamtamInstafeed(params, context) {
		var option, value;
		this.options = {
		  target: 'instafeed',
		  get: 'popular',
		  resolution: 'thumbnail',
		  sortBy: 'none',
		  links: true,
		  mock: false,
		  useHttp: false
		};
		if (typeof params === 'object') {
		  for (option in params) {
			value = params[option];
			this.options[option] = value;
		  }
		}
		this.context = context != null ? context : this;
		this.unique = this._genKey();
	  }

	  VamtamInstafeed.prototype.hasNext = function() {
		return typeof this.context.nextUrl === 'string' && this.context.nextUrl.length > 0;
	  };

	  VamtamInstafeed.prototype.next = function() {
		if (!this.hasNext()) {
		  return false;
		}
		return this.run(this.context.nextUrl);
	  };

	  VamtamInstafeed.prototype.run = function(url) {
		var header, instanceName, script;
		if (typeof this.options.clientId !== 'string') {
		  if (typeof this.options.accessToken !== 'string') {
			throw new Error("Missing clientId or accessToken.");
		  }
		}
		if (typeof this.options.accessToken !== 'string') {
		  if (typeof this.options.clientId !== 'string') {
			throw new Error("Missing clientId or accessToken.");
		  }
		}
		if ((this.options.before != null) && typeof this.options.before === 'function') {
		  this.options.before.call(this);
		}
		if (typeof document !== "undefined" && document !== null) {
		  script = document.createElement('script');
		  script.id = 'instafeed-fetcher';
		  script.src = url || this._buildUrl();
		  header = document.getElementsByTagName('head');
		  header[0].appendChild(script);
		  instanceName = "instafeedCache" + this.unique;
		  window[instanceName] = new VamtamInstafeed(this.options, this);
		  window[instanceName].unique = this.unique;
		}
		return true;
	  };

	  VamtamInstafeed.prototype.parse = function(response) {
		var anchor, childNodeCount, childNodeIndex, childNodesArr, e, eMsg, fragment, header, htmlString, httpProtocol, i, image, imageObj, imageString, imageUrl, images, img, imgHeight, imgOrient, imgUrl, imgWidth, instanceName, j, k, len, len1, len2, node, parsedLimit, reverse, sortSettings, targetEl, tmpEl;
		if (typeof response !== 'object') {
		  if ((this.options.error != null) && typeof this.options.error === 'function') {
			this.options.error.call(this, 'Invalid JSON data');
			return false;
		  } else {
			throw new Error('Invalid JSON response');
		  }
		}
		if (response.meta.code !== 200) {
		  if ((this.options.error != null) && typeof this.options.error === 'function') {
			this.options.error.call(this, response.meta.error_message);
			return false;
		  } else {
			throw new Error("Error from Instagram: " + response.meta.error_message);
		  }
		}
		if (response.data.length === 0) {
		  if ((this.options.error != null) && typeof this.options.error === 'function') {
			this.options.error.call(this, 'No images were returned from Instagram');
			return false;
		  } else {
			throw new Error('No images were returned from Instagram');
		  }
		}
		if ((this.options.success != null) && typeof this.options.success === 'function') {
		  this.options.success.call(this, response);
		}
		this.context.nextUrl = '';
		if (response.pagination != null) {
		  this.context.nextUrl = response.pagination.next_url;
		}
		if (this.options.sortBy !== 'none') {
		  if (this.options.sortBy === 'random') {
			sortSettings = ['', 'random'];
		  } else {
			sortSettings = this.options.sortBy.split('-');
		  }
		  reverse = sortSettings[0] === 'least' ? true : false;
		  switch (sortSettings[1]) {
			case 'random':
			  response.data.sort(function() {
				return 0.5 - Math.random();
			  });
			  break;
			case 'recent':
			  response.data = this._sortBy(response.data, 'created_time', reverse);
			  break;
			case 'liked':
			  response.data = this._sortBy(response.data, 'likes.count', reverse);
			  break;
			case 'commented':
			  response.data = this._sortBy(response.data, 'comments.count', reverse);
			  break;
			default:
			  throw new Error("Invalid option for sortBy: '" + this.options.sortBy + "'.");
		  }
		}
		if ((typeof document !== "undefined" && document !== null) && this.options.mock === false) {
		  images = response.data;
		  parsedLimit = parseInt(this.options.limit, 10);
		  if ((this.options.limit != null) && images.length > parsedLimit) {
			images = images.slice(0, parsedLimit);
		  }
		  fragment = document.createDocumentFragment();
		  if ((this.options.filter != null) && typeof this.options.filter === 'function') {
			images = this._filter(images, this.options.filter);
		  }
		  if ((this.options.template != null) && typeof this.options.template === 'string') {
			htmlString = '';
			imageString = '';
			imgUrl = '';
			tmpEl = document.createElement('div');
			for (i = 0, len = images.length; i < len; i++) {
			  image = images[i];
			  imageObj = image.images[this.options.resolution];
			  if (typeof imageObj !== 'object') {
				eMsg = "No image found for resolution: " + this.options.resolution + ".";
				throw new Error(eMsg);
			  }
			  imgWidth = imageObj.width;
			  imgHeight = imageObj.height;
			  imgOrient = "square";
			  if (imgWidth > imgHeight) {
				imgOrient = "landscape";
			  }
			  if (imgWidth < imgHeight) {
				imgOrient = "portrait";
			  }
			  imageUrl = imageObj.url;
			  httpProtocol = window.location.protocol.indexOf("http") >= 0;
			  if (httpProtocol && !this.options.useHttp) {
				imageUrl = imageUrl.replace(/https?:\/\//, '//');
			  }
			  imageString = this._makeTemplate(this.options.template, {
				model: image,
				id: image.id,
				link: image.link,
				type: image.type,
				image: imageUrl,
				width: imgWidth,
				height: imgHeight,
				orientation: imgOrient,
				caption: this._getObjectProperty(image, 'caption.text'),
				likes: image.likes.count,
				comments: image.comments.count,
				location: this._getObjectProperty(image, 'location.name')
			  });
			  htmlString += imageString;
			}
			tmpEl.innerHTML = htmlString;
			childNodesArr = [];
			childNodeIndex = 0;
			childNodeCount = tmpEl.childNodes.length;
			while (childNodeIndex < childNodeCount) {
			  childNodesArr.push(tmpEl.childNodes[childNodeIndex]);
			  childNodeIndex += 1;
			}
			for (j = 0, len1 = childNodesArr.length; j < len1; j++) {
			  node = childNodesArr[j];
			  fragment.appendChild(node);
			}
		  } else {
			for (k = 0, len2 = images.length; k < len2; k++) {
			  image = images[k];
			  img = document.createElement('img');
			  imageObj = image.images[this.options.resolution];
			  if (typeof imageObj !== 'object') {
				eMsg = "No image found for resolution: " + this.options.resolution + ".";
				throw new Error(eMsg);
			  }
			  imageUrl = imageObj.url;
			  httpProtocol = window.location.protocol.indexOf("http") >= 0;
			  if (httpProtocol && !this.options.useHttp) {
				imageUrl = imageUrl.replace(/https?:\/\//, '//');
			  }
			  img.src = imageUrl;
			  if (this.options.links === true) {
				anchor = document.createElement('a');
				anchor.href = image.link;
				anchor.appendChild(img);
				fragment.appendChild(anchor);
			  } else {
				fragment.appendChild(img);
			  }
			}
		  }
		  targetEl = this.options.target;
		  if (typeof targetEl === 'string') {
			targetEl = document.getElementById(targetEl);
		  }
		  if (targetEl == null) {
			eMsg = "No element with id=\"" + this.options.target + "\" on page.";
			throw new Error(eMsg);
		  }
		  targetEl.appendChild(fragment);
		  header = document.getElementsByTagName('head')[0];
		  header.removeChild(document.getElementById('instafeed-fetcher'));
		  instanceName = "instafeedCache" + this.unique;
		  window[instanceName] = void 0;
		  try {
			delete window[instanceName];
		  } catch (_error) {
			e = _error;
		  }
		}
		if ((this.options.after != null) && typeof this.options.after === 'function') {
		  this.options.after.call(this);
		}
		return true;
	  };

	  VamtamInstafeed.prototype._buildUrl = function() {
		var base, endpoint, final;
		base = "https://api.instagram.com/v1";
		switch (this.options.get) {
		  case "popular":
			endpoint = "media/popular";
			break;
		  case "tagged":
			if (!this.options.tagName) {
			  throw new Error("No tag name specified. Use the 'tagName' option.");
			}
			endpoint = "tags/" + this.options.tagName + "/media/recent";
			break;
		  case "location":
			if (!this.options.locationId) {
			  throw new Error("No location specified. Use the 'locationId' option.");
			}
			endpoint = "locations/" + this.options.locationId + "/media/recent";
			break;
		  case "user":
			if (!this.options.userId) {
			  throw new Error("No user specified. Use the 'userId' option.");
			}
			endpoint = "users/" + this.options.userId + "/media/recent";
			break;
		  default:
			throw new Error("Invalid option for get: '" + this.options.get + "'.");
		}
		final = base + "/" + endpoint;
		if (this.options.accessToken != null) {
		  final += "?access_token=" + this.options.accessToken;
		} else {
		  final += "?client_id=" + this.options.clientId;
		}
		if (this.options.limit != null) {
		  final += "&count=" + this.options.limit;
		}
		final += "&callback=instafeedCache" + this.unique + ".parse";
		return final;
	  };

	  VamtamInstafeed.prototype._genKey = function() {
		var S4;
		S4 = function() {
		  return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
		};
		return "" + (S4()) + (S4()) + (S4()) + (S4());
	  };

	  VamtamInstafeed.prototype._makeTemplate = function(template, data) {
		var output, pattern, ref, varName, varValue;
		pattern = /(?:\{{2})([\w\[\]\.]+)(?:\}{2})/;
		output = template;
		while (pattern.test(output)) {
		  varName = output.match(pattern)[1];
		  varValue = (ref = this._getObjectProperty(data, varName)) != null ? ref : '';
		  output = output.replace(pattern, function() {
			return "" + varValue;
		  });
		}
		return output;
	  };

	  VamtamInstafeed.prototype._getObjectProperty = function(object, property) {
		var piece, pieces;
		property = property.replace(/\[(\w+)\]/g, '.$1');
		pieces = property.split('.');
		while (pieces.length) {
		  piece = pieces.shift();
		  if ((object != null) && piece in object) {
			object = object[piece];
		  } else {
			return null;
		  }
		}
		return object;
	  };

	  VamtamInstafeed.prototype._sortBy = function(data, property, reverse) {
		var sorter;
		sorter = function(a, b) {
		  var valueA, valueB;
		  valueA = this._getObjectProperty(a, property);
		  valueB = this._getObjectProperty(b, property);
		  if (reverse) {
			if (valueA > valueB) {
			  return 1;
			} else {
			  return -1;
			}
		  }
		  if (valueA < valueB) {
			return 1;
		  } else {
			return -1;
		  }
		};
		data.sort(sorter.bind(this));
		return data;
	  };

	  VamtamInstafeed.prototype._filter = function(images, filter) {
		var filteredImages, fn, i, image, len;
		filteredImages = [];
		fn = function(image) {
		  if (filter(image)) {
			return filteredImages.push(image);
		  }
		};
		for (i = 0, len = images.length; i < len; i++) {
		  image = images[i];
		  fn(image);
		}
		return filteredImages;
	  };

	  return VamtamInstafeed;

	})();

	(function(root, factory) {
	  if (typeof define === 'function' && define.amd) {
		return define([], factory);
	  } else if (typeof module === 'object' && module.exports) {
		return module.exports = factory();
	  } else {
		return root.VamtamInstafeed = factory();
	  }
	})(this, function() {
	  return VamtamInstafeed;
	});
}).call(this);

;(function($) {
	VamtamInstagramFeed = function( settings ) {
		this.id 		= settings.id;
		this.username 	= 'undefined' !== typeof settings.username ? settings.username : '';
		this.byHashtag 	= 'undefined' !== typeof settings.byHashtag ? settings.byHashtag : false;
		this.hashtag 	= 'undefined' !== typeof settings.hashtag ? settings.hashtag : '';
		this.settings 	= settings;
		this.host 		= 'https://www.instagram.com/';

		this.node 		= $('.elementor-element-' + this.id);
		this.wrapper 	= this.node.find( '#vamtam-instafeed-' + this.id );

		this._data		= false;
		this._swiper	= {};

		this._init();
	};

	VamtamInstagramFeed.prototype = {
		_data: false,
		_swiper: {},

		_init: function() {
			if ( '' === this.username && ! this.settings.isBuilderActive ) {
				console.error('PP Instagram Feed (' + this.id + '): No username provided.');
				return;
				//throw new Error( 'PP Instagram Feed (' + this.id + '): No username provided.' );
			}

			var url = this.host + this.username + '/';
			this._getData( url, $.proxy( this._renderData, this ) );
		},

		_getData: function( url, callback ) {
			if ( this._data && 'function' === typeof callback ) {
				callback( this._data );
				return;
			}

			var self = this;
			$.get( url, function( data ) {
				data = self._processData( data );
				if ( 'function' === typeof callback ) {
					callback( data );
				}
			} ).fail(function(e) {
				console.error('PP Instagram Feed ('+ self.id +'): Unable to fetch the given user. Instagram responded with the status code: ', e.status);
			} );
		},

		_processData: function( data ) {
			data = data.split("window._sharedData = ")[1].split("<\/script>")[0];
			data = JSON.parse(data.substr(0, data.length - 1));
			data = data.entry_data.ProfilePage || data.entry_data.TagPage;
			data = data[0].graphql.user || data[0].graphql.hashtag;

			this._data = data;

			return data;
		},

		_renderData: function( data ) {
			//console.log(data);

			var html = '';
			var itemClass = 'vamtam-feed-item';

			if ( 'carousel' === this.settings.layout ) {
				itemClass += ' swiper-slide';
			}

			if ( data.is_private ) {
				html = '<p>This account is private.</p>';
			} else {
				var imgs = (data.edge_owner_to_timeline_media || data.edge_hashtag_to_media).edges;
				var max = (imgs.length > this.settings.limit) ? this.settings.limit : imgs.length;

				for (var i = 0; i < max; i++ ) {
					var url = "https://www.instagram.com/p/" + imgs[i].node.shortcode,
						thumb,
						type,
						caption = '',
						likes = imgs[i].node.edge_liked_by.count,
						comments = imgs[i].node.edge_media_to_comment.count;

					switch ( imgs[i].node.__typename ) {
						case "GraphSidecar":
							type = "sidecar"
							thumb = imgs[i].node.thumbnail_resources[4].src;
							break;
						case "GraphVideo":
							type = "video";
							thumb = imgs[i].node.thumbnail_src
							break;
						default:
							type = "image";
							thumb = imgs[i].node.thumbnail_resources[4].src;
					}

					if ( 'image' == type ) {
						image = 'square-grid' !== this.settings.layout ? imgs[i].node.display_url : thumb;
					} else {
						image = thumb;
					}

					// Caption.
					if ( imgs[i].node.edge_media_to_caption.edges.length > 0 ) {
						caption = imgs[i].node.edge_media_to_caption.edges[0].node.text;
					}

					// Start feed wrapper.
					html += '<div class="' + itemClass + '">';
					html += '<div class="vamtam-feed-item-inner">';

					// Start feed inner wrapper.
					/*if ( this.settings.image_size > 0 && 'grid' !== this.settings.layout ) {
						html += '<div class="vamtam-feed-item-inner" style="background-image: url( ' + image + ' )">';
					} else {
						html += '<div class="vamtam-feed-item-inner">';
					}*/

					// Start link.
					if ( 'no' !== this.settings.on_click ) {
						var link = 'yes' === this.settings.on_click ? imgs[i].node.display_url : url;
						html += '<a href="' + link + '" target="_blank" rel="nofollow noopener">'
					}
					html += '<div class="vamtam-if-img">';

					// Start overlay container.
					html += '<div class="vamtam-overlay-container">';

					if ( this.settings.likes_count ) {
						html += '<span class="likes"><i class="vamtam-if-icon fa fa-heart"></i> ' + likes + '</span>';
					}
					if ( this.settings.comments_count ) {
						html += '<span class="comments"><i class="vamtam-if-icon fa fa-comment"></i> ' + comments + '</span>';
					}

					// End overlay container.
					html += '</div>';

					// Image.
					/*if ( ( '' === this.settings.image_size || 0 === this.settings.image_size ) || 'grid' === this.settings.layout ) {
						html += '<img src="' + image + '" alt="' + caption + '" />'
					}*/

					html += '<img src="' + image + '" alt="' + caption + '" />'

					html += '</div>';

					// End link.
					if ( 'no' !== this.settings.on_click ) {
						html += '</a>';
					}

					// End feed inner wrapper.
					html += '</div>';
					html += '</div>';

					// End feed wrapper.
					html += '</div>';
				}
			}

			this.wrapper.html( html );

			if ( 'carousel' === this.settings.layout ) {
				this._initCarousel();
			} else if ( 'masonry' === this.settings.layout ) {
				this._initMasonry();
			} else {
				this._initGrid();
			}
		},

		_initGrid: function() {
			var grid = $('#vamtam-instafeed-' + this.id).imagesLoaded( function() {

			});
		},

		_initMasonry: function() {
			var grid = $('#vamtam-instafeed-' + this.id).imagesLoaded( function() {
				grid.masonry({
					itemSelector: '.vamtam-feed-item',
					percentPosition: true
				});
			});
		},

		_initCarousel: async function() {
            if ( 'undefined' === typeof Swiper ) {
                const Swiper = elementorFrontend.utils.swiper;
                this._swiper = await new Swiper( '.elementor-element-' + this.id + ' .vamtam-instagram-feed-carousel .swiper-container', this.settings.carousel );
            } else {
                this._swiper = new Swiper( '.elementor-element-' + this.id + ' .vamtam-instagram-feed-carousel .swiper-container', this.settings.carousel );
            }
		}
	};
})(jQuery);

var getElementSettings = function( $element ) {
	var elementSettings = {},
		modelCID 		= $element.data( 'model-cid' );

	if ( isEditMode && modelCID ) {
		var settings 		= elementorFrontend.config.elements.data[ modelCID ],
			settingsKeys 	= elementorFrontend.config.elements.keys[ settings.attributes.widgetType || settings.attributes.elType ];

		jQuery.each( settings.getActiveControls(), function( controlKey ) {
			if ( -1 !== settingsKeys.indexOf( controlKey ) ) {
				elementSettings[ controlKey ] = settings.attributes[ controlKey ];
			}
		} );
	} else {
		elementSettings = $element.data('settings') || {};
	}

	return elementSettings;
};

var isEditMode = !jQuery( 'body' ).hasClass( 'elementor-editor-active' );

var VamtamInstaFeedPopupHandler = function ( $scope ) {
	var widget_id					= $scope.data('id'),
		instafeed_elem              = $scope.find('.vamtam-instagram-feed').eq(0),
		elementSettings				= getElementSettings( $scope ),
		settings                    = instafeed_elem.data('settings'),
		taregt_id					= settings.target,
		vamtam_popup                = settings.popup,
		layout                    	= elementSettings.feed_layout,
		likes                    	= elementSettings.insta_likes,
		comments                    = elementSettings.insta_comments,
		icons_style                 = (elementSettings.icons_style === 'outline') ? '-o' : '',
		like_span                   = (likes === 'yes') ? '<span class="likes"><i class="vamtam-if-icon fa fa-heart' + icons_style + '"></i> {{likes}}</span>' : '',
		comments_span               = (comments === 'yes') ? '<span class="comments"><i class="vamtam-if-icon fa fa-comment' + icons_style + '"></i> {{comments}}</span>' : '',
		$more_button                = instafeed_elem.find('.vamtam-load-more-button');

	var $slider_options;

	if (layout === 'carousel') {
		var $carousel       = $scope.find('.swiper-container').eq(0),
			$slider_options = JSON.parse( $carousel.attr('data-slider-settings') );
	}

	if ( elementSettings.use_api === 'yes' ) {
		if ( settings.user_id && settings.access_token ) {
			var feed = new Instafeed({
				get:                    'user',
				userId:                 settings.user_id,
				sortBy:                 settings.sort_by,
				accessToken:            settings.access_token,
				limit:                  settings.images_count,
				target:                 taregt_id,
				resolution:             settings.resolution,
				orientation:            'portrait',
				template:               function () {
					if (vamtam_popup === '1') {
						if (layout === 'carousel') {
							return '<div class="vamtam-feed-item swiper-slide"><div class="vamtam-feed-item-inner"><a href="{{image}}"><div class="vamtam-if-img"><div class="vamtam-overlay-container">' + like_span + comments_span + '</div><img src="{{image}}" /></div></a></div></div>';
						} else {
							return '<div class="vamtam-feed-item"><div class="vamtam-feed-item-inner"><a href="{{image}}"><div class="vamtam-if-img"><div class="vamtam-overlay-container">' + like_span + comments_span + '</div><img src="{{image}}" /></div></a></div></div>';
						}
					} else {
						if (layout === 'carousel') {
							return '<div class="vamtam-feed-item swiper-slide"><div class="vamtam-feed-item-inner">' +
								'<a href="{{link}}">' +
									'<div class="vamtam-if-img">' +
									'<div class="vamtam-overlay-container">' + like_span + comments_span + '</div>' +
									'<img src="{{image}}" />' +
									'</div>' +
								'</a>' +
								'</div></div>';
						} else {
							return '<div class="vamtam-feed-item"><div class="vamtam-feed-item-inner">' +
								'<a href="{{link}}">' +
									'<div class="vamtam-if-img">' +
									'<div class="vamtam-overlay-container">' + like_span + comments_span + '</div>' +
									'<img src="{{image}}" />' +
									'</div>' +
								'</a>' +
								'</div></div>';
						}
					}
				}(),
				after: async function () {
					if (layout === 'carousel') {
                        var mySwiper;
                        if ( 'undefined' === typeof Swiper ) {
                            const Swiper = elementorFrontend.utils.swiper;
                            mySwiper = await new Swiper($carousel, $slider_options);
                        } else {
                            mySwiper = new Swiper($carousel, $slider_options);
                        }
					}
					if (layout === 'masonry') {
						var grid = $('#vamtam-instafeed-' + widget_id).imagesLoaded( function() {
							grid.masonry({
								itemSelector: '.vamtam-feed-item',
								percentPosition: true
							});
						});
					}
					if (!this.hasNext()) {
						$more_button.attr('disabled', 'disabled');
					}
				},
				success: function() {
					$more_button.removeClass( 'vamtam-button-loading' );
					$more_button.find( '.vamtam-load-more-button-text' ).html( 'Load More' );
				}
			});



			$more_button.on('click', function() {
				feed.next();
				$more_button.addClass( 'vamtam-button-loading' );
				$more_button.find( '.vamtam-load-more-button-text' ).html( 'Loading...' );
			});

			feed.run();

			if (vamtam_popup === '1') {
				jQuery(taregt_id).each(function () {
					jQuery(this).magnificPopup({
						delegate: 'div a', // child items selector, by clicking on it popup will open
						gallery: {
							enabled: true,
							navigateByImgClick: true,
							preload: [0, 1]
						},
						type: 'image'
					});
				});
			}
		}
	} else {
		var vamtam_feed = new VamtamInstagramFeed({
				id: widget_id,
				username: elementSettings.username,
				layout: layout,
				limit: settings.images_count,
				likes_count: (likes === 'yes'),
				comments_count: (comments === 'yes'),
				carousel: $slider_options,
			});
	}
};

jQuery( window ).on( 'elementor/frontend/init', () => {
	elementorFrontend.hooks.addAction('frontend/element_ready/vamtam-instafeed.default', VamtamInstaFeedPopupHandler);
} );
