<?php
namespace VamtamElementor\Widgets\Section;

// Extending the Section widget.

function update_bg_attachment_control( $controls_manager, $widget ) {
	// Bg Attachment.
	\Vamtam_Elementor_Utils::replace_control_options( $controls_manager, $widget, 'background_attachment', [
		'prefix_class' => 'vamtam-section-bg-',
	] );
}

// Styles - Background section.
function section_background_before_section_end( $widget, $args ) {
	$controls_manager = \Elementor\Plugin::instance()->controls_manager;
	update_bg_attachment_control( $controls_manager, $widget );
}
add_action( 'elementor/element/section/section_background/before_section_end', __NAMESPACE__ . '\section_background_before_section_end', 10, 2 );

// Add custom shapes to section's shape divider.
function additional_shapes( $additional_shapes ) {
	$additional_shapes = $additional_shapes + [
		'vamtam-waves' => [
			'title'        => _x( 'Vamtam Waves', 'Shapes', 'vamtam-elementor-integration' ),
			'height_only'  => true,
			'path'         => VAMTAM_ELEMENTOR_INT_DIR . 'assets/shapes/vamtam-waves.svg',
			'url'          => VAMTAM_ELEMENTOR_INT_URL . 'assets/shapes/vamtam-waves.svg'
		]
	];
	return $additional_shapes;
}
add_filter( 'elementor/shapes/additional_shapes', __NAMESPACE__ . '\additional_shapes' );
