<?php
namespace VamtamElementor\Widgets\ProductDataTabs;

// Extending the WC Product Data Tabs widget.

// Is WC Widget.
if ( ! vamtam_has_woocommerce() ) {
	return;
}

// Is Pro Widget.
if ( ! \VamtamElementorIntregration::is_elementor_pro_active() ) {
	return;
}

if ( vamtam_theme_supports( 'woocommerce-product-data-tabs--fitness-tabs-style' ) ) {
	function use_theme_btn_style_control( $controls_manager, $widget ) {
		$widget->start_injection( [
			'of' => 'wc_style_warning',
		] );
		$widget->add_control(
			'use_theme_style',
			[
				'label' => __( 'Use Theme Style', 'vamtam-elementor-integration' ),
				'type' => $controls_manager::SWITCHER,
				'prefix_class' => 'vamtam-has-',
				'return_value' => 'theme-style',
				'default' => 'theme-style',
			]
		);
		$widget->end_injection();
	}
	function section_product_tabs_style_before_section_end( $widget, $args ) {
		$controls_manager = \Elementor\Plugin::instance()->controls_manager;
		use_theme_btn_style_control( $controls_manager, $widget );
	}
	add_action( 'elementor/element/woocommerce-product-data-tabs/section_product_tabs_style/before_section_end', __NAMESPACE__ . '\section_product_tabs_style_before_section_end', 10, 2 );
}
